#ifndef _ECA_REGION_H
#define _ECA_REGION_H

class ECA_REGION {

 private:

  bool region_active_rep;
  bool region_looping_rep;
  bool region_sfx_control_rep;

  long int region_start_pos;
  long int region_end_pos;

 public:

  void region_start_pos_in_seconds(double value);
  void region_end_pos_in_seconds(double value);
  double region_start_pos_in_seconds(void) const;
  double region_end_pos_in_seconds(void) const;

  void region_start_pos_in_samples(long int value);
  void region_end_pos_in_samples(long int value);
  long int region_start_pos_in_samples(void) const;
  long int region_end_pos_in_samples(void) const;

  void enable_active_looping(void) { region_active_rep = true; }
  void enable_region_looping(void) { region_looping_rep = true; }
  void enable_region_sfx_control(void) { region_sfx_control_rep = true; }

  bool region_active(void) const { return(region_active_rep); }
  bool region_looping(void) const { return(region_looping_rep); }
  bool region_sfx_control(void) const { return(region_sfx_control_rep); }

  ECA_REGION(void);
};

#endif

